import ModelComponent from "../../db/ModelComponent";
import MagicLink from "./MagicLink";
import {USERNAME_REGEXP} from "./UserNameComponent";
import User from "./User";

export default class MagicLinkUserNameComponent extends ModelComponent<MagicLink> {
    public readonly username?: string = undefined;

    protected init(): void {
        this.setValidation('username').acceptUndefined().between(3, 64).regexp(USERNAME_REGEXP).unique(User, 'name');
    }
}
